;
; Oyd11, 3rd try on GBA: Trialish vcopper-bars
; TODO.... setup interrupts first... start coding... blah... blah.
; assembled with goldroad ARM 1.7
;

	b start
	
	@dup dcb 0xba,0				; room for header

start



palSet:
;;  set pal: entries are 256x555bpp I think
	mov	r0,#0x05000000 ; palette address
;
	mov r1,#32
	mov r2,#0 ; 0BGR
;
.r
	strh    r2,[r0,#2]!			; store colour
;
	add r2,r2,#1      ; r

	subs r1,r1,#1
	bpl .r

	mov r1,#32
	mov r2,#0 ; 0BGR
;
.g
	strh    r2,[r0,#2]!			; store colour
;
	add r2,r2,#(1<<5)      ; g

	subs r1,r1,#1
	bpl .g

	mov r1,#32
	mov r2,#0 ; 0BGR

.b
	strh    r2,[r0,#2]!			; store colour
;
	add r2,r2,#(1<<10)      ; b

	subs r1,r1,#1
	bpl .b

	mov r1,#32
	mov r2,#0 ; 0BGR

.gray
	strh    r2,[r0,#2]!			; store colour
;
	add r2,r2,#1      ; r
	add r2,r2,#(1<<5)      ;g
	add r2,r2,#(1<<10)      ; b

	subs r1,r1,#1
	bpl .gray

	; 128 entries

	mov r1,#32
	mov r2,#0 ; 0BGR

.yellow
	strh    r2,[r0,#2]!			; store colour
;
	add r2,r2,#1      ; r
	add r2,r2,#(1<<5)      ;g

	subs r1,r1,#1
	bpl .yellow

	mov r1,#32
	mov r2,#0 ; 0BGR

.cyan
	strh    r2,[r0,#2]!			; store colour
;
	add r2,r2,#(1<<5)      ;g
	add r2,r2,#(1<<10)      ; b

	subs r1,r1,#1
	bpl .cyan

	mov r1,#32
	mov r2,#0 ; 0BGR

.magenta
	strh    r2,[r0,#2]!			; store colour
;
	add r2,r2,#1      ; r
	add r2,r2,#(1<<10)      ; b

	subs r1,r1,#1
	bpl .magenta

	mov r1,#32
	mov r2,#(31<<10)
.blue2White
	strh    r2,[r0,#2]!			; store colour
;
	add r2,r2,#1      ; r
	add r2,r2,#(1<<10)      ; b

	subs r1,r1,#1
	bpl .blue2White

	; 256 entries



;
;; Set video mode
;
	mov	r0,#0x04000000			; regs
	ldr	r1,=0x1444			; mode 4,bg 2 enabled,obj enabled,1d sprites
	str	r1,[r0]				; set screen mode



	mov r6,#(1<<8)
effect:
; Res is 240x160

	;; strip patt:
bigLoop:
	mov 	r0,#0x06000000			; video ram
	mov	r3,160
l1:
	mov r2,240
l0:
	eor r4,r2,r3
	add r4,r4,r5
	strb 	r4,[r0],#1
	subs 	r2,r2,#1
	bne  	l0
	subs r3,r3,#1
	bne l1

;;	wait vsync
;	
	mov 	r1,#0x06000000			; vram
	mov	r0,#$04000000
waitvbl:
	ldrh	r1,[r0,#4]
	tst	r1,#1
	beq	waitvbl


	add r5,r5,1

	mov r0,#0x04000000
;	add r0,r0,#0x028 ; bg x-scroll
	add r0,r0,#0x02c ; bg x-scroll

	tst r5,#(1<<13)
	mvneq r6,r6
	add r6,r6,#1

	add r5,r5,r6

	str r5,[r0]

	b	bigLoop
	

